b9589defaa99d310053550d096ffcd8d48a023fd
[flac.git] / test / test_flac.sh
1 #!/bin/sh
2
3 #  FLAC - Free Lossless Audio Codec
4 #  Copyright (C) 2001,2002,2003,2004  Josh Coalson
5 #
6 #  This file is part the FLAC project.  FLAC is comprised of several
7 #  components distributed under difference licenses.  The codec libraries
8 #  are distributed under Xiph.Org's BSD-like license (see the file
9 #  COPYING.Xiph in this distribution).  All other programs, libraries, and
10 #  plugins are distributed under the GPL (see COPYING.GPL).  The documentation
11 #  is distributed under the Gnu FDL (see COPYING.FDL).  Each file in the
12 #  FLAC distribution contains at the top the terms under which it may be
13 #  distributed.
14 #
15 #  Since this particular file is relevant to all components of FLAC,
16 #  it may be distributed under the Xiph.Org license, which is the least
17 #  restrictive of those mentioned above.  See the file COPYING.Xiph in this
18 #  distribution.
19
20 die ()
21 {
22         echo $* 1>&2
23         exit 1
24 }
25
26 LD_LIBRARY_PATH=../src/libFLAC/.libs:../obj/release/lib:../obj/debug/lib:$LD_LIBRARY_PATH
27 export LD_LIBRARY_PATH
28 PATH=../src/flac:../src/metaflac:../src/test_streams:../obj/release/bin:../obj/debug/bin:$PATH
29
30 flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable"
31
32 run_flac ()
33 {
34         if [ x"$FLAC__VALGRIND" = xyes ] ; then
35                 valgrind --leak-check=yes --show-reachable=yes --num-callers=100 --logfile-fd=4 flac $* 4>>test_flac.valgrind.log
36         else
37                 flac $*
38         fi
39 }
40
41 if [ `env | grep -ic '^comspec='` != 0 ] ; then
42         is_win=yes
43 else
44         is_win=no
45 fi
46
47 echo "Checking for --ogg support in flac..."
48 if flac --ogg --silent --force-raw-format --endian=little --sign=signed --channels=1 --bps=8 --sample-rate=44100 -c $0 1>/dev/null 2>&1 ; then
49         has_ogg=yes;
50         echo "flac --ogg works"
51 else
52         has_ogg=no;
53         echo "flac --ogg doesn't work"
54 fi
55
56
57 echo "Generating streams..."
58 if [ ! -f wacky1.wav ] ; then
59         test_streams || die "ERROR during test_streams"
60 fi
61
62 ############################################################################
63 # test that flac doesn't automatically overwrite files unless -f is used
64 ############################################################################
65
66 echo "Try encoding to a file that exists; should fail"
67 cp wacky1.wav exist.wav
68 touch exist.flac
69 if run_flac --totally-silent -0 exist.wav ; then
70         die "ERROR: it should have failed but didn't"
71 else
72         echo "OK, it failed as it should"
73 fi
74
75 echo "Try encoding with -f to a file that exists; should succeed"
76 if run_flac --totally-silent -0 --force exist.wav ; then
77         echo "OK, it succeeded as it should"
78 else
79         die "ERROR: it should have succeeded but didn't"
80 fi
81
82 echo "Try decoding to a file that exists; should fail"
83 if run_flac --totally-silent -d exist.flac ; then
84         die "ERROR: it should have failed but didn't"
85 else
86         echo "OK, it failed as it should"
87 fi
88
89 echo "Try decoding with -f to a file that exists; should succeed"
90 if run_flac --totally-silent -d -f exist.flac ; then
91         echo "OK, it succeeded as it should"
92 else
93         die "ERROR: it should have succeeded but didn't"
94 fi
95
96 rm -f exist.wav exist.flac
97
98 ############################################################################
99 # basic 'round-trip' tests of various kinds of streams
100 ############################################################################
101
102 rt_test_raw ()
103 {
104         f="$1"
105         channels=`echo $f | awk -F- '{print $2}'`
106         bytes_per_sample=`echo $f | awk -F- '{print $3}'`
107         bps=`expr $bytes_per_sample '*' 8`
108         echo -n "round-trip test ($f) encode... "
109         run_flac --silent --force --verify --force-raw-format --endian=little --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $f -o rt.flac || die "ERROR"
110         echo -n "decode... "
111         run_flac --silent --force --decode --force-raw-format --endian=little --sign=signed -o rt.raw rt.flac || die "ERROR"
112         echo -n "compare... "
113         cmp $f rt.raw || die "ERROR: file mismatch"
114         echo "OK"
115         rm -f rt.flac rt.raw
116 }
117
118 rt_test_wav ()
119 {
120         f="$1"
121         echo -n "round-trip test ($f) encode... "
122         run_flac --silent --force --verify $f -o rt.flac || die "ERROR"
123         echo -n "decode... "
124         run_flac --silent --force --decode -o rt.wav rt.flac || die "ERROR"
125         echo -n "compare... "
126         cmp $f rt.wav || die "ERROR: file mismatch"
127         echo "OK"
128         rm -f rt.flac rt.wav
129 }
130
131 rt_test_aiff ()
132 {
133         f="$1"
134         echo -n "round-trip test ($f) encode... "
135         run_flac --silent --force --verify $f -o rt.flac || die "ERROR"
136         echo -n "decode... "
137         run_flac --silent --force --decode -o rt.aiff rt.flac || die "ERROR"
138         echo -n "compare... "
139         cmp $f rt.aiff || die "ERROR: file mismatch"
140         echo "OK"
141         rm -f rt.flac rt.aiff
142 }
143
144 for f in rt-*.raw ; do
145         rt_test_raw $f
146 done
147 for f in rt-*.wav ; do
148         rt_test_wav $f
149 done
150 for f in rt-*.aiff ; do
151         rt_test_aiff $f
152 done
153
154 ############################################################################
155 # test --skip and --until
156 ############################################################################
157
158 #
159 # first make some chopped-up raw files
160 #
161 echo "abcdefghijklmnopqrstuvwxyz1234567890ABCDEFGHIJKLMN" > master.raw
162 dddie="die ERROR: creating files for --skip/--until tests"
163 dd if=master.raw ibs=1 count=50 of=50c.raw 2>/dev/null || $dddie
164 dd if=master.raw ibs=1 skip=10 count=40 of=50c.skip10.raw 2>/dev/null || $dddie
165 dd if=master.raw ibs=1 skip=11 count=39 of=50c.skip11.raw 2>/dev/null || $dddie
166 dd if=master.raw ibs=1 skip=20 count=30 of=50c.skip20.raw 2>/dev/null || $dddie
167 dd if=master.raw ibs=1 skip=30 count=20 of=50c.skip30.raw 2>/dev/null || $dddie
168 dd if=master.raw ibs=1 skip=40 count=10 of=50c.skip40.raw 2>/dev/null || $dddie
169 dd if=master.raw ibs=1 count=10 of=50c.until10.raw 2>/dev/null || $dddie
170 dd if=master.raw ibs=1 count=20 of=50c.until20.raw 2>/dev/null || $dddie
171 dd if=master.raw ibs=1 count=30 of=50c.until30.raw 2>/dev/null || $dddie
172 dd if=master.raw ibs=1 count=39 of=50c.until39.raw 2>/dev/null || $dddie
173 dd if=master.raw ibs=1 count=40 of=50c.until40.raw 2>/dev/null || $dddie
174 dd if=master.raw ibs=1 skip=10 count=20 of=50c.skip10.until30.raw 2>/dev/null || $dddie
175 dd if=master.raw ibs=1 skip=10 count=29 of=50c.skip10.until39.raw 2>/dev/null || $dddie
176 dd if=master.raw ibs=1 skip=10 count=30 of=50c.skip10.until40.raw 2>/dev/null || $dddie
177 dd if=master.raw ibs=1 skip=20 count=10 of=50c.skip20.until30.raw 2>/dev/null || $dddie
178 dd if=master.raw ibs=1 skip=20 count=20 of=50c.skip20.until40.raw 2>/dev/null || $dddie
179
180 wav_eopt="--silent --force --verify --lax"
181 wav_dopt="--silent --force --decode"
182
183 raw_eopt="$wav_eopt --force-raw-format --endian=big --sign=signed --sample-rate=10 --bps=8 --channels=1"
184 raw_dopt="$wav_dopt --force-raw-format --endian=big --sign=signed"
185
186 #
187 # convert them to WAVE and AIFF files
188 #
189 convert_to_wav ()
190 {
191         run_flac $raw_eopt $1.raw || die "ERROR converting $1.raw to WAVE"
192         run_flac $wav_dopt $1.flac || die "ERROR converting $1.raw to WAVE"
193 }
194 convert_to_wav 50c
195 convert_to_wav 50c.skip10
196 convert_to_wav 50c.skip11
197 convert_to_wav 50c.skip20
198 convert_to_wav 50c.skip30
199 convert_to_wav 50c.skip40
200 convert_to_wav 50c.until10
201 convert_to_wav 50c.until20
202 convert_to_wav 50c.until30
203 convert_to_wav 50c.until39
204 convert_to_wav 50c.until40
205 convert_to_wav 50c.skip10.until30
206 convert_to_wav 50c.skip10.until39
207 convert_to_wav 50c.skip10.until40
208 convert_to_wav 50c.skip20.until30
209 convert_to_wav 50c.skip20.until40
210
211 convert_to_aiff ()
212 {
213         run_flac $raw_eopt $1.raw || die "ERROR converting $1.raw to AIFF"
214         run_flac $wav_dopt $1.flac -o $1.aiff || die "ERROR converting $1.raw to AIFF"
215 }
216 convert_to_aiff 50c
217 convert_to_aiff 50c.skip10
218 convert_to_aiff 50c.skip11
219 convert_to_aiff 50c.skip20
220 convert_to_aiff 50c.skip30
221 convert_to_aiff 50c.skip40
222 convert_to_aiff 50c.until10
223 convert_to_aiff 50c.until20
224 convert_to_aiff 50c.until30
225 convert_to_aiff 50c.until39
226 convert_to_aiff 50c.until40
227 convert_to_aiff 50c.skip10.until30
228 convert_to_aiff 50c.skip10.until39
229 convert_to_aiff 50c.skip10.until40
230 convert_to_aiff 50c.skip20.until30
231 convert_to_aiff 50c.skip20.until40
232
233 test_skip_until ()
234 {
235         in_fmt=$1
236         out_fmt=$2
237
238         [ "$in_fmt" = wav ] || [ "$in_fmt" = aiff ] || [ "$in_fmt" = raw ] || die "ERROR: internal error, bad 'in' format '$in_fmt'"
239
240         [ "$out_fmt" = flac ] || [ "$out_fmt" = ogg ] || die "ERROR: internal error, bad 'out' format '$out_fmt'"
241
242         if [ $in_fmt = raw ] ; then
243                 eopt="$raw_eopt"
244                 dopt="$raw_dopt"
245         else
246                 eopt="$wav_eopt"
247                 dopt="$wav_dopt"
248         fi
249
250         if [ $out_fmt = ogg ] ; then
251                 eopt="--ogg $eopt"
252         fi
253
254         #
255         # test --skip when encoding
256         #
257
258         desc="($in_fmt<->$out_fmt)"
259
260         echo -n "testing --skip=# (encode) $desc... "
261         run_flac $eopt --skip=10 -o z50c.skip10.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
262         run_flac $dopt -o z50c.skip10.$in_fmt z50c.skip10.$out_fmt || die "ERROR decoding FLAC file $desc"
263         cmp 50c.skip10.$in_fmt z50c.skip10.$in_fmt || die "ERROR: file mismatch for --skip=10 (encode) $desc"
264         rm -f z50c.skip10.$out_fmt z50c.skip10.$in_fmt
265         echo OK
266
267         echo -n "testing --skip=mm:ss (encode) $desc... "
268         run_flac $eopt --skip=0:01 -o z50c.skip0:01.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
269         run_flac $dopt -o z50c.skip0:01.$in_fmt z50c.skip0:01.$out_fmt || die "ERROR decoding FLAC file $desc"
270         cmp 50c.skip10.$in_fmt z50c.skip0:01.$in_fmt || die "ERROR: file mismatch for --skip=0:01 (encode) $desc"
271         rm -f z50c.skip0:01.$out_fmt z50c.skip0:01.$in_fmt
272         echo OK
273
274         echo -n "testing --skip=mm:ss.sss (encode) $desc... "
275         run_flac $eopt --skip=0:01.1001 -o z50c.skip0:01.1001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
276         run_flac $dopt -o z50c.skip0:01.1001.$in_fmt z50c.skip0:01.1001.$out_fmt || die "ERROR decoding FLAC file $desc"
277         cmp 50c.skip11.$in_fmt z50c.skip0:01.1001.$in_fmt || die "ERROR: file mismatch for --skip=0:01.1001 (encode) $desc"
278         rm -f z50c.skip0:01.1001.$out_fmt z50c.skip0:01.1001.$in_fmt
279         echo OK
280
281         #
282         # test --skip when decoding
283         #
284
285         echo -n "testing --skip=# (decode) $desc... "
286         run_flac $eopt -o z50c.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
287         run_flac $dopt --skip=10 -o z50c.skip10.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
288         cmp 50c.skip10.$in_fmt z50c.skip10.$in_fmt || die "ERROR: file mismatch for --skip=10 (decode) $desc"
289         rm -f z50c.skip10.$in_fmt
290         echo OK
291
292         echo -n "testing --skip=mm:ss (decode) $desc... "
293         run_flac $dopt --skip=0:01 -o z50c.skip0:01.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
294         cmp 50c.skip10.$in_fmt z50c.skip0:01.$in_fmt || die "ERROR: file mismatch for --skip=0:01 (decode) $desc"
295         rm -f z50c.skip0:01.$in_fmt
296         echo OK
297
298         echo -n "testing --skip=mm:ss.sss (decode) $desc... "
299         run_flac $dopt --skip=0:01.1001 -o z50c.skip0:01.1001.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
300         cmp 50c.skip11.$in_fmt z50c.skip0:01.1001.$in_fmt || die "ERROR: file mismatch for --skip=0:01.1001 (decode) $desc"
301         rm -f z50c.skip0:01.1001.$in_fmt
302         echo OK
303
304         rm -f z50c.$out_fmt
305
306         #
307         # test --until when encoding
308         #
309
310         echo -n "testing --until=# (encode) $desc... "
311         run_flac $eopt --until=40 -o z50c.until40.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
312         run_flac $dopt -o z50c.until40.$in_fmt z50c.until40.$out_fmt || die "ERROR decoding FLAC file $desc"
313         cmp 50c.until40.$in_fmt z50c.until40.$in_fmt || die "ERROR: file mismatch for --until=40 (encode) $desc"
314         rm -f z50c.until40.$out_fmt z50c.until40.$in_fmt
315         echo OK
316
317         echo -n "testing --until=mm:ss (encode) $desc... "
318         run_flac $eopt --until=0:04 -o z50c.until0:04.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
319         run_flac $dopt -o z50c.until0:04.$in_fmt z50c.until0:04.$out_fmt || die "ERROR decoding FLAC file $desc"
320         cmp 50c.until40.$in_fmt z50c.until0:04.$in_fmt || die "ERROR: file mismatch for --until=0:04 (encode) $desc"
321         rm -f z50c.until0:04.$out_fmt z50c.until0:04.$in_fmt
322         echo OK
323
324         echo -n "testing --until=mm:ss.sss (encode) $desc... "
325         run_flac $eopt --until=0:03.9001 -o z50c.until0:03.9001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
326         run_flac $dopt -o z50c.until0:03.9001.$in_fmt z50c.until0:03.9001.$out_fmt || die "ERROR decoding FLAC file $desc"
327         cmp 50c.until39.$in_fmt z50c.until0:03.9001.$in_fmt || die "ERROR: file mismatch for --until=0:03.9001 (encode) $desc"
328         rm -f z50c.until0:03.9001.$out_fmt z50c.until0:03.9001.$in_fmt
329         echo OK
330
331         echo -n "testing --until=-# (encode) $desc... "
332         run_flac $eopt --until=-10 -o z50c.until-10.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
333         run_flac $dopt -o z50c.until-10.$in_fmt z50c.until-10.$out_fmt || die "ERROR decoding FLAC file $desc"
334         cmp 50c.until40.$in_fmt z50c.until-10.$in_fmt || die "ERROR: file mismatch for --until=-10 (encode) $desc"
335         rm -f z50c.until-10.$out_fmt z50c.until-10.$in_fmt
336         echo OK
337
338         echo -n "testing --until=-mm:ss (encode) $desc... "
339         run_flac $eopt --until=-0:01 -o z50c.until-0:01.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
340         run_flac $dopt -o z50c.until-0:01.$in_fmt z50c.until-0:01.$out_fmt || die "ERROR decoding FLAC file $desc"
341         cmp 50c.until40.$in_fmt z50c.until-0:01.$in_fmt || die "ERROR: file mismatch for --until=-0:01 (encode) $desc"
342         rm -f z50c.until-0:01.$out_fmt z50c.until-0:01.$in_fmt
343         echo OK
344
345         echo -n "testing --until=-mm:ss.sss (encode) $desc... "
346         run_flac $eopt --until=-0:01.1001 -o z50c.until-0:01.1001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
347         run_flac $dopt -o z50c.until-0:01.1001.$in_fmt z50c.until-0:01.1001.$out_fmt || die "ERROR decoding FLAC file $desc"
348         cmp 50c.until39.$in_fmt z50c.until-0:01.1001.$in_fmt || die "ERROR: file mismatch for --until=-0:01.1001 (encode) $desc"
349         rm -f z50c.until-0:01.1001.$out_fmt z50c.until-0:01.1001.$in_fmt
350         echo OK
351
352         #
353         # test --until when decoding
354         #
355
356         run_flac $eopt -o z50c.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
357
358         echo -n "testing --until=# (decode) $desc... "
359         run_flac $dopt --until=40 -o z50c.until40.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
360         cmp 50c.until40.$in_fmt z50c.until40.$in_fmt || die "ERROR: file mismatch for --until=40 (decode) $desc"
361         rm -f z50c.until40.$in_fmt
362         echo OK
363
364         echo -n "testing --until=mm:ss (decode) $desc... "
365         run_flac $dopt --until=0:04 -o z50c.until0:04.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
366         cmp 50c.until40.$in_fmt z50c.until0:04.$in_fmt || die "ERROR: file mismatch for --until=0:04 (decode) $desc"
367         rm -f z50c.until0:04.$in_fmt
368         echo OK
369
370         echo -n "testing --until=mm:ss.sss (decode) $desc... "
371         run_flac $dopt --until=0:03.9001 -o z50c.until0:03.9001.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
372         cmp 50c.until39.$in_fmt z50c.until0:03.9001.$in_fmt || die "ERROR: file mismatch for --until=0:03.9001 (decode) $desc"
373         rm -f z50c.until0:03.9001.$in_fmt
374         echo OK
375
376         echo -n "testing --until=-# (decode) $desc... "
377         run_flac $dopt --until=-10 -o z50c.until-10.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
378         cmp 50c.until40.$in_fmt z50c.until-10.$in_fmt || die "ERROR: file mismatch for --until=-10 (decode) $desc"
379         rm -f z50c.until-10.$in_fmt
380         echo OK
381
382         echo -n "testing --until=-mm:ss (decode) $desc... "
383         run_flac $dopt --until=-0:01 -o z50c.until-0:01.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
384         cmp 50c.until40.$in_fmt z50c.until-0:01.$in_fmt || die "ERROR: file mismatch for --until=-0:01 (decode) $desc"
385         rm -f z50c.until-0:01.$in_fmt
386         echo OK
387
388         echo -n "testing --until=-mm:ss.sss (decode) $desc... "
389         run_flac $dopt --until=-0:01.1001 -o z50c.until-0:01.1001.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
390         cmp 50c.until39.$in_fmt z50c.until-0:01.1001.$in_fmt || die "ERROR: file mismatch for --until=-0:01.1001 (decode) $desc"
391         rm -f z50c.until-0:01.1001.$in_fmt
392         echo OK
393
394         rm -f z50c.$out_fmt
395
396         #
397         # test --skip and --until when encoding
398         #
399
400         echo -n "testing --skip=10 --until=# (encode) $desc... "
401         run_flac $eopt --skip=10 --until=40 -o z50c.skip10.until40.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
402         run_flac $dopt -o z50c.skip10.until40.$in_fmt z50c.skip10.until40.$out_fmt || die "ERROR decoding FLAC file $desc"
403         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until40.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=40 (encode) $desc"
404         rm -f z50c.skip10.until40.$out_fmt z50c.skip10.until40.$in_fmt
405         echo OK
406
407         echo -n "testing --skip=10 --until=mm:ss (encode) $desc... "
408         run_flac $eopt --skip=10 --until=0:04 -o z50c.skip10.until0:04.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
409         run_flac $dopt -o z50c.skip10.until0:04.$in_fmt z50c.skip10.until0:04.$out_fmt || die "ERROR decoding FLAC file $desc"
410         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until0:04.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=0:04 (encode) $desc"
411         rm -f z50c.skip10.until0:04.$out_fmt z50c.skip10.until0:04.$in_fmt
412         echo OK
413
414         echo -n "testing --skip=10 --until=mm:ss.sss (encode) $desc... "
415         run_flac $eopt --skip=10 --until=0:03.9001 -o z50c.skip10.until0:03.9001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
416         run_flac $dopt -o z50c.skip10.until0:03.9001.$in_fmt z50c.skip10.until0:03.9001.$out_fmt || die "ERROR decoding FLAC file $desc"
417         cmp 50c.skip10.until39.$in_fmt z50c.skip10.until0:03.9001.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=0:03.9001 (encode) $desc"
418         rm -f z50c.skip10.until0:03.9001.$out_fmt z50c.skip10.until0:03.9001.$in_fmt
419         echo OK
420
421         echo -n "testing --skip=10 --until=+# (encode) $desc... "
422         run_flac $eopt --skip=10 --until=+30 -o z50c.skip10.until+30.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
423         run_flac $dopt -o z50c.skip10.until+30.$in_fmt z50c.skip10.until+30.$out_fmt || die "ERROR decoding FLAC file $desc"
424         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until+30.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=+30 (encode) $desc"
425         rm -f z50c.skip10.until+30.$out_fmt z50c.skip10.until+30.$in_fmt
426         echo OK
427
428         echo -n "testing --skip=10 --until=+mm:ss (encode) $desc... "
429         run_flac $eopt --skip=10 --until=+0:03 -o z50c.skip10.until+0:03.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
430         run_flac $dopt -o z50c.skip10.until+0:03.$in_fmt z50c.skip10.until+0:03.$out_fmt || die "ERROR decoding FLAC file $desc"
431         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until+0:03.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=+0:03 (encode) $desc"
432         rm -f z50c.skip10.until+0:03.$out_fmt z50c.skip10.until+0:03.$in_fmt
433         echo OK
434
435         echo -n "testing --skip=10 --until=+mm:ss.sss (encode) $desc... "
436         run_flac $eopt --skip=10 --until=+0:02.9001 -o z50c.skip10.until+0:02.9001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
437         run_flac $dopt -o z50c.skip10.until+0:02.9001.$in_fmt z50c.skip10.until+0:02.9001.$out_fmt || die "ERROR decoding FLAC file $desc"
438         cmp 50c.skip10.until39.$in_fmt z50c.skip10.until+0:02.9001.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=+0:02.9001 (encode) $desc"
439         rm -f z50c.skip10.until+0:02.9001.$out_fmt z50c.skip10.until+0:02.9001.$in_fmt
440         echo OK
441
442         echo -n "testing --skip=10 --until=-# (encode) $desc... "
443         run_flac $eopt --skip=10 --until=-10 -o z50c.skip10.until-10.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
444         run_flac $dopt -o z50c.skip10.until-10.$in_fmt z50c.skip10.until-10.$out_fmt || die "ERROR decoding FLAC file $desc"
445         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until-10.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-10 (encode) $desc"
446         rm -f z50c.skip10.until-10.$out_fmt z50c.skip10.until-10.$in_fmt
447         echo OK
448
449         echo -n "testing --skip=10 --until=-mm:ss (encode) $desc... "
450         run_flac $eopt --skip=10 --until=-0:01 -o z50c.skip10.until-0:01.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
451         run_flac $dopt -o z50c.skip10.until-0:01.$in_fmt z50c.skip10.until-0:01.$out_fmt || die "ERROR decoding FLAC file $desc"
452         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until-0:01.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-0:01 (encode) $desc"
453         rm -f z50c.skip10.until-0:01.$out_fmt z50c.skip10.until-0:01.$in_fmt
454         echo OK
455
456         echo -n "testing --skip=10 --until=-mm:ss.sss (encode) $desc... "
457         run_flac $eopt --skip=10 --until=-0:01.1001 -o z50c.skip10.until-0:01.1001.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
458         run_flac $dopt -o z50c.skip10.until-0:01.1001.$in_fmt z50c.skip10.until-0:01.1001.$out_fmt || die "ERROR decoding FLAC file $desc"
459         cmp 50c.skip10.until39.$in_fmt z50c.skip10.until-0:01.1001.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-0:01.1001 (encode) $desc"
460         rm -f z50c.skip10.until-0:01.1001.$out_fmt z50c.skip10.until-0:01.1001.$in_fmt
461         echo OK
462
463         #
464         # test --skip and --until when decoding
465         #
466
467         run_flac $eopt -o z50c.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
468
469         echo -n "testing --skip=10 --until=# (decode) $desc... "
470         run_flac $dopt --skip=10 --until=40 -o z50c.skip10.until40.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
471         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until40.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=40 (decode) $desc"
472         rm -f z50c.skip10.until40.$in_fmt
473         echo OK
474
475         echo -n "testing --skip=10 --until=mm:ss (decode) $desc... "
476         run_flac $dopt --skip=10 --until=0:04 -o z50c.skip10.until0:04.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
477         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until0:04.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=0:04 (decode) $desc"
478         rm -f z50c.skip10.until0:04.$in_fmt
479         echo OK
480
481         echo -n "testing --skip=10 --until=mm:ss.sss (decode) $desc... "
482         run_flac $dopt --skip=10 --until=0:03.9001 -o z50c.skip10.until0:03.9001.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
483         cmp 50c.skip10.until39.$in_fmt z50c.skip10.until0:03.9001.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=0:03.9001 (decode) $desc"
484         rm -f z50c.skip10.until0:03.9001.$in_fmt
485         echo OK
486
487         echo -n "testing --skip=10 --until=-# (decode) $desc... "
488         run_flac $dopt --skip=10 --until=-10 -o z50c.skip10.until-10.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
489         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until-10.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-10 (decode) $desc"
490         rm -f z50c.skip10.until-10.$in_fmt
491         echo OK
492
493         echo -n "testing --skip=10 --until=-mm:ss (decode) $desc... "
494         run_flac $dopt --skip=10 --until=-0:01 -o z50c.skip10.until-0:01.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
495         cmp 50c.skip10.until40.$in_fmt z50c.skip10.until-0:01.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-0:01 (decode) $desc"
496         rm -f z50c.skip10.until-0:01.$in_fmt
497         echo OK
498
499         echo -n "testing --skip=10 --until=-mm:ss.sss (decode) $desc... "
500         run_flac $dopt --skip=10 --until=-0:01.1001 -o z50c.skip10.until-0:01.1001.$in_fmt z50c.$out_fmt || die "ERROR decoding FLAC file $desc"
501         cmp 50c.skip10.until39.$in_fmt z50c.skip10.until-0:01.1001.$in_fmt || die "ERROR: file mismatch for --skip=10 --until=-0:01.1001 (decode) $desc"
502         rm -f z50c.skip10.until-0:01.1001.$in_fmt
503         echo OK
504
505         rm -f z50c.$out_fmt
506 }
507
508 test_skip_until raw flac
509 test_skip_until wav flac
510 test_skip_until aiff flac
511
512 if [ $has_ogg = "yes" ] ; then
513         test_skip_until raw ogg
514         test_skip_until wav ogg
515         test_skip_until aiff ogg
516 fi
517
518 echo "Testing seek extremes:"
519
520 run_flac --verify --force --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=16 --channels=2 --blocksize=576 noise.raw || die "ERROR generating FLAC file"
521
522 if [ $is_win = no ] ; then
523         total_samples=`metaflac --show-total-samples noise.flac`
524         [ $? = 0 ] || die "ERROR getting total sample count from noise.flac"
525 else
526         # some flavors of cygwin don't seem to treat the \x0d as a word
527         # separator, so we hard code it.  we'll just have to fix it later
528         # if we change the way noise.flac is made.
529         total_samples=393216
530 fi
531
532 echo -n "Testing --skip=0... "
533 run_flac $wav_dopt --skip=0 -o z.wav noise.flac || die "ERROR decoding FLAC file noise.flac"
534 echo OK
535
536 for delta in 2 1 ; do
537         n=`expr $total_samples - $delta`
538         echo -n "Testing --skip=$n... "
539         run_flac $wav_dopt --skip=$n -o z.wav noise.flac || die "ERROR decoding FLAC file noise.flac"
540         echo OK
541 done
542
543 rm noise.flac z.wav
544
545
546 ############################################################################
547 # test --cue
548 ############################################################################
549
550 #
551 # create the cue sheet
552 #
553 cuesheet=cuetest.cue
554 cat > $cuesheet << EOF
555 CATALOG 1234567890123
556 FILE "blah" WAVE
557   TRACK 01 AUDIO
558     INDEX 01 0
559     INDEX 02 10
560     INDEX 03 20
561   TRACK 02 AUDIO
562     INDEX 01 30
563   TRACK 04 AUDIO
564     INDEX 01 40
565 EOF
566
567 test_cue ()
568 {
569         in_fmt=$1
570         out_fmt=$2
571
572         [ "$in_fmt" = wav ] || [ "$in_fmt" = aiff ] || [ "$in_fmt" = raw ] || die "ERROR: internal error, bad 'in' format '$in_fmt'"
573
574         [ "$out_fmt" = flac ] || [ "$out_fmt" = ogg ] || die "ERROR: internal error, bad 'out' format '$out_fmt'"
575
576         if [ $in_fmt = raw ] ; then
577                 eopt="$raw_eopt"
578                 dopt="$raw_dopt"
579         else
580                 eopt="$wav_eopt"
581                 dopt="$wav_dopt"
582         fi
583
584         if [ $out_fmt = ogg ] ; then
585                 eopt="--ogg $eopt"
586         fi
587
588         desc="($in_fmt<->$out_fmt)"
589
590         #
591         # for this we need just need just one FLAC file; --cue only works while decoding
592         #
593         run_flac $eopt --cuesheet=$cuesheet -o z50c.cue.$out_fmt 50c.$in_fmt || die "ERROR generating FLAC file $desc"
594
595         # To make it easy to translate from cue point to sample numbers, the
596         # file has a sample rate of 10 Hz and a cuesheet like so:
597         #
598         # TRACK 01, INDEX 01 : 0:00.00 -> sample 0
599         # TRACK 01, INDEX 02 : 0:01.00 -> sample 10
600         # TRACK 01, INDEX 03 : 0:02.00 -> sample 20
601         # TRACK 02, INDEX 01 : 0:03.00 -> sample 30
602         # TRACK 04, INDEX 01 : 0:04.00 -> sample 40
603         #
604         echo -n "testing --cue=- $desc... "
605         run_flac $dopt -o z50c.cue.$in_fmt --cue=- z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
606         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=- $desc"
607         rm -f z50c.cue.$in_fmt
608         echo OK
609
610         echo -n "testing --cue=1.0 $desc... "
611         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.0 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
612         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.0 $desc"
613         rm -f z50c.cue.$in_fmt
614         echo OK
615
616         echo -n "testing --cue=1.0- $desc... "
617         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.0- z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
618         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.0- $desc"
619         rm -f z50c.cue.$in_fmt
620         echo OK
621
622         echo -n "testing --cue=1.1 $desc... "
623         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.1 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
624         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.1 $desc"
625         rm -f z50c.cue.$in_fmt
626         echo OK
627
628         echo -n "testing --cue=1.1- $desc... "
629         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.1- z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
630         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.1- $desc"
631         rm -f z50c.cue.$in_fmt
632         echo OK
633
634         echo -n "testing --cue=1.2 $desc... "
635         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.2 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
636         cmp 50c.skip10.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.2 $desc"
637         rm -f z50c.cue.$in_fmt
638         echo OK
639
640         echo -n "testing --cue=1.2- $desc... "
641         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.2- z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
642         cmp 50c.skip10.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.2- $desc"
643         rm -f z50c.cue.$in_fmt
644         echo OK
645
646         echo -n "testing --cue=1.4 $desc... "
647         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.4 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
648         cmp 50c.skip20.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.4 $desc"
649         rm -f z50c.cue.$in_fmt
650         echo OK
651
652         echo -n "testing --cue=1.4- $desc... "
653         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.4- z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
654         cmp 50c.skip20.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.4- $desc"
655         rm -f z50c.cue.$in_fmt
656         echo OK
657
658         echo -n "testing --cue=-5.0 $desc... "
659         run_flac $dopt -o z50c.cue.$in_fmt --cue=-5.0 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
660         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=-5.0 $desc"
661         rm -f z50c.cue.$in_fmt
662         echo OK
663
664         echo -n "testing --cue=-4.1 $desc... "
665         run_flac $dopt -o z50c.cue.$in_fmt --cue=-4.1 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
666         cmp 50c.until40.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=-4.1 $desc"
667         rm -f z50c.cue.$in_fmt
668         echo OK
669
670         echo -n "testing --cue=-3.1 $desc... "
671         run_flac $dopt -o z50c.cue.$in_fmt --cue=-3.1 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
672         cmp 50c.until40.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=-3.1 $desc"
673         rm -f z50c.cue.$in_fmt
674         echo OK
675
676         echo -n "testing --cue=-1.4 $desc... "
677         run_flac $dopt -o z50c.cue.$in_fmt --cue=-1.4 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
678         cmp 50c.until30.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=-1.4 $desc"
679         rm -f z50c.cue.$in_fmt
680         echo OK
681
682         echo -n "testing --cue=1.0-5.0 $desc... "
683         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.0-5.0 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
684         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.0-5.0 $desc"
685         rm -f z50c.cue.$in_fmt
686         echo OK
687
688         echo -n "testing --cue=1.1-5.0 $desc... "
689         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.1-5.0 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
690         cmp 50c.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.1-5.0 $desc"
691         rm -f z50c.cue.$in_fmt
692         echo OK
693
694         echo -n "testing --cue=1.2-4.1 $desc... "
695         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.2-4.1 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
696         cmp 50c.skip10.until40.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.2-4.1 $desc"
697         rm -f z50c.cue.$in_fmt
698         echo OK
699
700         echo -n "testing --cue=1.4-2.0 $desc... "
701         run_flac $dopt -o z50c.cue.$in_fmt --cue=1.4-2.0 z50c.cue.$out_fmt || die "ERROR decoding FLAC file $desc"
702         cmp 50c.skip20.until30.$in_fmt z50c.cue.$in_fmt || die "ERROR: file mismatch for --cue=1.4-2.0 $desc"
703         rm -f z50c.cue.$in_fmt
704         echo OK
705
706         rm -f z50c.cue.$out_fmt
707 }
708
709 test_cue raw flac
710 test_cue wav flac
711 test_cue aiff flac
712
713 if [ $has_ogg = "yes" ] ; then
714         test_cue raw ogg
715         test_cue wav ogg
716         test_cue aiff ogg
717 fi
718
719 ############################################################################
720 # test 'fixup' code that happens when a FLAC file with total_samples == 0
721 # in the STREAMINFO block is converted to WAVE or AIFF, requiring the
722 # decoder go back and fix up the chunk headers
723 ############################################################################
724
725 echo -n "WAVE fixup test... "
726
727 echo -n "prepare... "
728 convert_to_wav noise || die "ERROR creating reference WAVE"
729
730 echo -n "encode... "
731 # the pipe from 'cat' to 'flac' does not work on cygwin because of the EOF/
732 # binary-mode stdin problem, so we use an undocumented option to metaflac to
733 # set the total sample count to 0
734 if [ $is_win = yes ] ; then
735         run_flac $raw_eopt noise.raw -o fixup.flac || die "ERROR generating FLAC file"
736         metaflac --set-total-samples=0 fixup.flac 2> /dev/null
737 else
738         cat noise.raw | run_flac $raw_eopt - -c > fixup.flac || die "ERROR generating FLAC file"
739 fi
740
741 echo -n "decode... "
742 run_flac $wav_dopt fixup.flac -o fixup.wav || die "ERROR decoding FLAC file"
743
744 echo -n "compare... "
745 cmp noise.wav fixup.wav || die "ERROR: file mismatch"
746
747 echo OK
748 rm -f noise.wav fixup.wav fixup.flac
749
750 echo -n "AIFF fixup test... "
751
752 echo -n "prepare... "
753 convert_to_aiff noise || die "ERROR creating reference AIFF"
754
755 echo -n "encode... "
756 # the pipe from 'cat' to 'flac' does not work on cygwin because of the EOF/
757 # binary-mode stdin problem, so we use an undocumented option to metaflac to
758 # set the total sample count to 0
759 if [ $is_win = yes ] ; then
760         run_flac $raw_eopt noise.raw -o fixup.flac || die "ERROR generating FLAC file"
761         metaflac --set-total-samples=0 fixup.flac 2> /dev/null
762 else
763         cat noise.raw | run_flac $raw_eopt - -c > fixup.flac || die "ERROR generating FLAC file"
764 fi
765
766 echo -n "decode... "
767 run_flac $wav_dopt fixup.flac -o fixup.aiff || die "ERROR decoding FLAC file"
768
769 echo -n "compare... "
770 cmp noise.aiff fixup.aiff || die "ERROR: file mismatch"
771
772 echo OK
773 rm -f noise.aiff fixup.aiff fixup.flac
774
775
776 ############################################################################
777 # multi-file tests
778 ############################################################################
779
780 echo "Generating multiple input files from noise..."
781 run_flac --verify --force --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=16 --channels=2 noise.raw || die "ERROR generating FLAC file"
782 run_flac --decode --force --silent noise.flac || die "ERROR generating WAVE file"
783 rm -f noise.flac
784 mv noise.wav file0.wav
785 cp file0.wav file1.wav
786 cp file1.wav file2.wav
787
788 test_multifile ()
789 {
790         streamtype=$1
791         sector_align=$2
792         encode_options="$3"
793
794         if [ $streamtype = ogg ] ; then
795                 suffix=ogg
796                 encode_options="$encode_options --ogg"
797         else
798                 suffix=flac
799         fi
800
801         if [ $sector_align = sector_align ] ; then
802                 encode_options="$encode_options --sector-align"
803         fi
804
805         run_flac --force $encode_options file0.wav file1.wav file2.wav || die "ERROR"
806         for n in 0 1 2 ; do
807                 mv file$n.$suffix file${n}x.$suffix
808         done
809         run_flac --force --decode file0x.$suffix file1x.$suffix file2x.$suffix || die "ERROR"
810         if [ $sector_align != sector_align ] ; then
811                 for n in 0 1 2 ; do
812                         cmp file$n.wav file${n}x.wav || die "ERROR: file mismatch on file #$n"
813                 done
814         fi
815         for n in 0 1 2 ; do
816                 rm -f file${n}x.$suffix file${n}x.wav
817         done
818 }
819
820 echo "Testing multiple files without verify..."
821 test_multifile flac no_sector_align ""
822
823 echo "Testing multiple files with verify..."
824 test_multifile flac no_sector_align "--verify"
825
826 echo "Testing multiple files with --sector-align, without verify..."
827 test_multifile flac sector_align ""
828
829 echo "Testing multiple files with --sector-align, with verify..."
830 test_multifile flac sector_align "--verify"
831
832 if [ $has_ogg = "yes" ] ; then
833         echo "Testing multiple files with --ogg, without verify..."
834         test_multifile ogg no_sector_align ""
835
836         echo "Testing multiple files with --ogg, with verify..."
837         test_multifile ogg no_sector_align "--verify"
838
839         echo "Testing multiple files with --ogg and --sector-align, without verify..."
840         test_multifile ogg sector_align ""
841
842         echo "Testing multiple files with --ogg and --sector-align, with verify..."
843         test_multifile sector_align ogg "--verify"
844
845         echo "Testing multiple files with --ogg and --serial-number, with verify..."
846         test_multifile ogg no_sector_align "--serial-number=321 --verify"
847 fi